
if exists (select * from sysobjects where id = object_id(N'[dbo].[bookinfo]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[bookinfo]
GO

if exists (select * from sysobjects where id = object_id(N'[dbo].[byroyalty]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[byroyalty]
GO

if exists (select * from sysobjects where id = object_id(N'[dbo].[getauthor]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[getauthor]
GO

if exists (select * from sysobjects where id = object_id(N'[dbo].[giveraise]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[giveraise]
GO

if exists (select * from sysobjects where id = object_id(N'[dbo].[remauthor]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[remauthor]
GO

if exists (select * from sysobjects where id = object_id(N'[dbo].[sp_delete_authors_1]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[sp_delete_authors_1]
GO

if exists (select * from sysobjects where id = object_id(N'[dbo].[sp_delete_publishers_1]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[sp_delete_publishers_1]
GO

if exists (select * from sysobjects where id = object_id(N'[dbo].[sp_delete_titles_1]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[sp_delete_titles_1]
GO

if exists (select * from sysobjects where id = object_id(N'[dbo].[sp_get_title_1]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[sp_get_title_1]
GO

if exists (select * from sysobjects where id = object_id(N'[dbo].[sp_getauthortitle]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[sp_getauthortitle]
GO

if exists (select * from sysobjects where id = object_id(N'[dbo].[sp_insert_roysched_1]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[sp_insert_roysched_1]
GO

if exists (select * from sysobjects where id = object_id(N'[dbo].[sp_insert_titles_1]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[sp_insert_titles_1]
GO

if exists (select * from sysobjects where id = object_id(N'[dbo].[sp_update_titles_1]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[sp_update_titles_1]
GO

if exists (select * from sysobjects where id = object_id(N'[dbo].[authors_VIEW]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[authors_VIEW]
GO

if exists (select * from sysobjects where id = object_id(N'[dbo].[titleview]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[titleview]
GO



SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

CREATE VIEW [authors_VIEW]
AS SELECT [authors].[au_id],  [authors].[au_fname] + ' ' +  [authors].[au_lname] 'author'
FROM [authors]


GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  OFF 
GO


CREATE VIEW titleview
AS
select title, au_ord, au_lname, price, ytd_sales, pub_id
from authors, titles, titleauthor
where authors.au_id = titleauthor.au_id
   AND titles.title_id = titleauthor.title_id


GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

CREATE PROCEDURE bookinfo @au_id varchar(11)
AS
select title, au_lname, au_fname, pub_name, price, ytd_sales 
from titleauthor, titles, authors, publishers
where titleauthor.au_id = @au_id and 
titles.title_id = titleauthor.title_id and
authors.au_id = titleauthor.au_id and 
publishers.pub_id = titles.pub_id

GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  OFF 
GO


CREATE PROCEDURE byroyalty @percentage int
AS
select au_id from titleauthor
where titleauthor.royaltyper = @percentage


GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

CREATE PROCEDURE getauthor @lastname varchar(20)
AS
BEGIN
select * from authors where au_lname = @lastname
select title, ytd_sales from titles where title_id in 
(select title_id from titleauthor where 
   au_id in (select au_id from authors where au_lname = @lastname))
END

GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

CREATE PROCEDURE giveraise @percentage VARCHAR(4)
AS
BEGIN
select au_lname, au_fname, title, royaltyper from authors, 
	titleauthor, titles where titleauthor.au_id = authors.au_id and 
	titles.title_id = titleauthor.title_id
update titleauthor set royaltyper = royaltyper +  Convert (int, @percentage)
select au_lname, au_fname, title, royaltyper from authors, 
	titleauthor, titles where titleauthor.au_id = authors.au_id and 
	titles.title_id = titleauthor.title_id
END
GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

CREATE PROCEDURE remauthor @lastname varchar(20)
AS
BEGIN
delete from titleauthor where au_id in 
(select au_id from authors where au_lname = @lastname)
delete from authors where au_lname = @lastname
END
GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

CREATE  PROCEDURE [sp_delete_authors_1]
	(@au_id_1 	id)

AS
BEGIN
DELETE [pubs].[dbo].[titleauthor]

WHERE
	( [au_id]	 = @au_id_1)

DELETE [pubs].[dbo].[authors] 

WHERE 
	( [au_id]	 = @au_id_1)
END


GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

CREATE  PROCEDURE [sp_delete_publishers_1]
	(@pub_id_1 	char(4))

AS 
BEGIN
DELETE [pubs].[dbo].[pub_info]
WHERE 
	( [pub_id]	 = @pub_id_1)

DELETE [pubs].[dbo].[publishers] 

WHERE 
	( [pub_id]	 = @pub_id_1)
END

GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

CREATE   PROCEDURE [sp_delete_titles_1]
	(@title_id_1 	tid)

AS 
BEGIN
DELETE [pubs].[dbo].[titleauthor]

WHERE
	( [title_id]	 = @title_id_1)

DELETE [pubs].[dbo].[roysched]

WHERE
	( [title_id]	 = @title_id_1)


DELETE [pubs].[dbo].[titles] 

WHERE 
	( [title_id]	 = @title_id_1)
END


GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

CREATE PROCEDURE [sp_get_title_1]
	(@titleid 	tid )

AS 
BEGIN
SELECT title, type, pub_name, price, advance, notes, pubdate 
FROM titles, publishers 
WHERE publishers.pub_id = titles.pub_id AND titles.title_id = @titleid

SELECT lorange, hirange, royalty 
FROM roysched where 
title_id = @titleid

SELECT au_fname + ' ' + au_lname 
FROM authors
WHERE au_id IN 
(SELECT au_id from titleauthor 
 WHERE title_id = @titleid)
END

GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

CREATE     PROCEDURE [sp_getauthortitle]
	(@author_name  VARCHAR(40) )

AS 
BEGIN
SELECT title, au_lname, au_fname 
FROM titles, authors, titleauthor
WHERE titleauthor.au_id = authors.au_id and titles.title_id = 
     titleauthor.title_id and 
     au_lname = @author_name
END

GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

CREATE PROCEDURE [sp_insert_roysched_1]
	(@title_id_1 	tid,
	 @lorange_2 	int,
	 @hirange_3 	int,
	 @royalty_4 	int)

AS INSERT INTO [pubs].[dbo].[roysched] 
	 ( [title_id],
	 [lorange],
	 [hirange],
	 [royalty]) 
 
VALUES 
	( @title_id_1,
	 @lorange_2,
	 @hirange_3,
	 @royalty_4)

GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

CREATE PROCEDURE [sp_insert_titles_1]
	(@title_id_1 	tid,
	 @title_2 	varchar(80),
	 @type_3 	char(12),
	 @pub_id_4 	char(4),
	 @price_5 	money,
	 @advance_6 	money,
	 @royalty_7 	int,
	 @ytd_sales_8 	int,
	 @notes_9 	varchar(200),
	 @pubdate_10 	datetime)

AS INSERT INTO [pubs].[dbo].[titles] 
	 ( [title_id],
	 [title],
	 [type],
	 [pub_id],
	 [price],
	 [advance],
	 [royalty],
	 [ytd_sales],
	 [notes],
	 [pubdate]) 
 
VALUES 
	( @title_id_1,
	 @title_2,
	 @type_3,
	 @pub_id_4,
	 @price_5,
	 @advance_6,
	 @royalty_7,
	 @ytd_sales_8,
	 @notes_9,
	 @pubdate_10)

GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

CREATE PROCEDURE [sp_update_titles_1]
	(@pub_id_1 	char(4),
	 @pub_id_2 	char(4))

AS UPDATE [pubs].[dbo].[titles] 

SET  [pub_id]	 = @pub_id_2 

WHERE 
	( [pub_id]	 = @pub_id_1)

GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

