// cssp.cpp : Implementation of Ccssp
#include "stdafx.h"
#include "CSSPDhtml.h"
#include "cssp.h"

/////////////////////////////////////////////////////////////////////////////
// Ccssp

STDMETHODIMP Ccssp::MoveLeft(BSTR bstrObject, int iBrowser, BSTR bstrValue, BSTR *pbstrDHTML)
{

	// to work with header
	CComBSTR bstrHeader("");
	if (!bstrHeader)
		return E_OUTOFMEMORY;

	// if browser type of 1 - IE
	if (iBrowser == 1) {
		bstrHeader=bstrObject;
		bstrHeader+=".style.left=";
		bstrHeader+=bstrValue;
	}
	else { // Navigator
		bstrHeader = "document."; 
		bstrHeader+=bstrObject;
		bstrHeader+=".left=";
		bstrHeader+=bstrValue;
	}

	// assign to return variable, set CComBSTR m_str to null
	*pbstrDHTML = bstrHeader.Detach();

	// return status code
	return S_OK;
}


// MoveTop
STDMETHODIMP Ccssp::MoveTop(BSTR bstrObject, int iBrowser, BSTR bstrValue, BSTR *pbstrDHTML)
{
	// to work with header
	CComBSTR bstrHeader("");
	if (!bstrHeader)
		return E_OUTOFMEMORY;

	// if browser type of 1 - IE
	if (iBrowser == 1) {
		bstrHeader=bstrObject;
		bstrHeader+=".style.top=";
		bstrHeader+=bstrValue;
	}
	else { // Navigator
		bstrHeader = "document."; 
		bstrHeader+=bstrObject;
		bstrHeader+=".top=";
		bstrHeader+=bstrValue;
	}

	// assign to return variable, set CComBSTR m_str to null
	*pbstrDHTML = bstrHeader.Detach();

	return S_OK;
}

// Hide
STDMETHODIMP Ccssp::Hide(BSTR bstrObject, int iBrowser, BSTR *pbstrDHTML)
{
	// to work with header
	CComBSTR bstrHeader("");
	if (!bstrHeader)
		return E_OUTOFMEMORY;

	// if browser type of 1 - IE
	if (iBrowser == 1) {
		bstrHeader=bstrObject;
		bstrHeader+=".style.visibility='hidden'";
	}
	else { // Navigator
		bstrHeader = "document."; 
		bstrHeader+=bstrObject;
		bstrHeader+=".visibility='hidden'";
	}

	// assign to return variable, set CComBSTR m_str to null
	*pbstrDHTML = bstrHeader.Detach();

	return S_OK;
}

// Show
STDMETHODIMP Ccssp::Show(BSTR bstrObject, int iBrowser, BSTR *pbstrDHTML)
{
	// to work with header
	CComBSTR bstrHeader("");
	if (!bstrHeader)
		return E_OUTOFMEMORY;

	// if browser type of 1 - IE
	if (iBrowser == 1) {
		bstrHeader=bstrObject;
		bstrHeader+=".style.visibility='inherit'";
	}
	else { // Navigator
		bstrHeader = "document."; 
		bstrHeader+=bstrObject;
		bstrHeader+=".visibility='inherit'";
	}

	// assign to return variable, set CComBSTR m_str to null
	*pbstrDHTML = bstrHeader.Detach();

	return S_OK;
}
