// objcontrol.cpp : Implementation of Cobjcontrol
#include "stdafx.h"
#include "CPPMtsObjControl.h"
#include "objcontrol.h"

/////////////////////////////////////////////////////////////////////////////
// Cobjcontrol

HRESULT Cobjcontrol::Activate()
{
   HRESULT hr = S_OK;
   CComBSTR bstrObj;
   CComVariant vt;
   CComPtr<IGetContextProperties> pProps; //Context Properties

   IDispatch* piDispatch = NULL;

   // generated code
	hr = GetObjectContext(&m_spObjectContext);
   if (FAILED(hr))
      return hr;

   // add in code to get built-in objects
   
   // get Context Properties
   hr = m_spObjectContext->QueryInterface( IID_IGetContextProperties, 
               (void**)&pProps );
   if (FAILED(hr)) 
       return hr;

   // get Response property
   bstrObj = "Response";
   hr = pProps->GetProperty( bstrObj, &vt ) ;

   if (FAILED(hr))
       return hr;

   piDispatch = vt. pdispVal;
   hr = piDispatch->QueryInterface( IID_IResponse, 
                     (void**)&m_piResponse );

   if (FAILED(hr))
       return hr;

   // get Request property
   bstrObj = "Request";
   hr = pProps->GetProperty( bstrObj, &vt ) ;

   if (FAILED(hr))
       return hr;

   piDispatch = vt. pdispVal;
   hr = piDispatch->QueryInterface( IID_IRequest, 
                     (void**)&m_piRequest );

   if (FAILED(hr))
       return hr;

   // get Application property
   bstrObj = "Application";
   hr = pProps->GetProperty( bstrObj, &vt ) ;

   if (FAILED(hr))
       return hr;

   piDispatch = vt. pdispVal;
   hr = piDispatch->QueryInterface( IID_IApplicationObject, 
                     (void**)&m_piApplication );

   if (FAILED(hr))
       return hr;

   // get Session property
   bstrObj = "Session";
   hr = pProps->GetProperty( bstrObj, &vt ) ;

   if (FAILED(hr))
       return hr;

   piDispatch = vt. pdispVal;
   hr = piDispatch->QueryInterface( IID_ISessionObject, 
                     (void**)&m_piSession );

   if (FAILED(hr))
       return hr;

   // get Server property
   bstrObj = "Server";
   hr = pProps->GetProperty( bstrObj, &vt ) ;

   if (FAILED(hr))
       return hr;

   piDispatch = vt. pdispVal;
   hr = piDispatch->QueryInterface( IID_IServer, 
                     (void**)&m_piServer );

   return hr;
} 

BOOL Cobjcontrol::CanBePooled()
{
	return TRUE;
} 

void Cobjcontrol::Deactivate()
{
   // release pointer refs to built-in ASP objects
   m_piResponse.Release();
   m_piRequest.Release();
   m_piApplication.Release();
   m_piSession.Release();
   m_piServer.Release();

   // release ObjectContext - generated code
   m_spObjectContext.Release();
} 


STDMETHODIMP Cobjcontrol::test()
{
   // write out header
   CComVariant vtHeader(OLESTR("<H1>This is a test</H1>"));
   m_piResponse->Write(vtHeader);

	return S_OK;
}
