// mytest.cpp : Implementation of Cmytest
#include "stdafx.h"
#include "MTSServer.h"
#include "mytest.h"

#import "embed.tlb" named_guids   // use old naming convention
#include "embed.h"

/////////////////////////////////////////////////////////////////////////////
// Cmytest

HRESULT Cmytest::Activate()
{
   HRESULT hr = S_OK;
   CComBSTR bstrObj;
   CComVariant vt;
   CComPtr<IGetContextProperties> pProps; //Context Properties

   IDispatch* piDispatch = NULL;

   // generated code
	hr = GetObjectContext(&m_spObjectContext);
   if (FAILED(hr))
      return hr;

   // add in code to get built-in objects
   
   // get Context Properties
   hr = m_spObjectContext->QueryInterface( IID_IGetContextProperties, 
               (void**)&pProps );
   if (FAILED(hr)) 
       return hr;

   // get Response property
   bstrObj = "Response";
   hr = pProps->GetProperty( bstrObj, &vt ) ;

   if (FAILED(hr))
       return hr;

   piDispatch = vt. pdispVal;
   hr = piDispatch->QueryInterface( IID_IResponse, 
                     (void**)&m_piResponse );

   if (FAILED(hr))
       return hr;


   // get Server property
   bstrObj = "Server";
   hr = pProps->GetProperty( bstrObj, &vt ) ;

   if (FAILED(hr))
       return hr;

   piDispatch = vt. pdispVal;
   hr = piDispatch->QueryInterface( IID_IServer, 
                     (void**)&m_piServer );

   return hr;
} 

BOOL Cmytest::CanBePooled()
{
	return TRUE;
} 

void Cmytest::Deactivate()
{
   // release pointer refs to built-in ASP objects
   m_piResponse.Release();
   m_piServer.Release();

   // release ObjectContext - generated code
   m_spObjectContext.Release();
} 



STDMETHODIMP Cmytest::test()
{
   HRESULT hr = S_OK;

   // HTML Encoding
   CComBSTR bstrIn("<H1>This is a test</H1>"), bstrOut;
   CComVariant vtOut, vtSeparator("<p>");

   m_piServer->HTMLEncode(bstrIn, &bstrOut);
   vtOut = bstrOut;

   m_piResponse->Write(vtOut);
   m_piResponse->Write(vtSeparator);

   // URL Encoding
   bstrIn = "% this is a test % ++";
   m_piServer->URLEncode(bstrIn, &bstrOut);

   vtOut = bstrOut;
   m_piResponse->Write(vtOut);
   m_piResponse->Write(vtSeparator);

   // path encoding
   bstrIn = "test/test2/this is a test";
   m_piServer->URLPathEncode(bstrIn, &bstrOut);

   vtOut = bstrOut;
   m_piResponse->Write(vtOut);
   m_piResponse->Write(vtSeparator);

   // path mapping
   bstrIn = "/test/test2/";
   m_piServer->MapPath(bstrIn, &bstrOut);

   vtOut = bstrOut;
   m_piResponse->Write(vtOut);


   return hr;
}

STDMETHODIMP Cmytest::thetest()
{
   HRESULT hr = S_OK;
   IDispatch* pDispatch = NULL;
   Iem* pEm = NULL;

   CComBSTR bstrProgID("Embed.em");

   hr = m_piServer->CreateObject(bstrProgID,&pDispatch);

      // cast to em interface object
   if (!FAILED(hr)) {
     hr = pDispatch->QueryInterface( IID_Iem, 
                  (void**)&pEm );
     if (FAILED(hr)) return hr;
     }

   // invoke server component's method
   hr = pEm->test();

   return hr;
}
