// objThree.cpp : Implementation of CobjThree
#include "stdafx.h"
#include "OLEDBOne.h"
#include "objThree.h"

/////////////////////////////////////////////////////////////////////////////
// CobjThree

HRESULT CobjThree::Activate()
{
   HRESULT hr = S_OK;
   CComBSTR bstrObj;
   CComVariant vt;
   CComPtr<IGetContextProperties> pProps; //Context Properties

   IDispatch* piDispatch = NULL;

   // generated code
	hr = GetObjectContext(&m_spObjectContext);
   if (FAILED(hr))
      return hr;

   // add in code to get built-in objects
   // get Context Properties
   hr = m_spObjectContext->QueryInterface( IID_IGetContextProperties, 
               (void**)&pProps );
   if (FAILED(hr)) 
       return hr;

   // get Response property
   bstrObj = "Response";
   hr = pProps->GetProperty( bstrObj, &vt ) ;

   if (FAILED(hr))
       return hr;

   piDispatch = vt.pdispVal;
   hr = piDispatch->QueryInterface( IID_IResponse, 
                     (void**)&m_piResponse );
   return hr;
} 

BOOL CobjThree::CanBePooled()
{
	return FALSE;
} 

void CobjThree::Deactivate()
{
   // release pointer refs to built-in ASP objects
   m_piResponse.Release();

   // release ObjectContext - generated code
	m_spObjectContext.Release();
} 


STDMETHODIMP CobjThree::test()
{
    CComVariant vbreak(OLESTR("<p>"));
    

    Cdboauthors author;
    author.Open();

    author.MoveFirst();

    while (author.MoveNext() == S_OK) {
        CComVariant vt(author.m_aulname);
        m_piResponse->Write(vt);
        m_piResponse->Write(vbreak);
    }

	return S_OK;
}
