VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "tstcntxt2"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private objResponse As Response
Private objContext As ObjectContext

' Using ObjectContext to pull in another MTS object
Public Sub objTestMTS(strHeader As String)

' define objects
 Dim objTest As mtstest
 Dim strHdr As String

On Error GoTo HandleError

  Set objContext = GetObjectContext()
  Set objResponse = objContext.Item("Response")

  ' access MTS object
  Set objTest = objContext.CreateInstance("testmts.mtstest")
  
  ' call MTS object functions, and use
  ' predefined Response object to write results
  strHdr = objTest.First(strHeader)
  objResponse.Write (strHdr)
  strHdr = objTest.Second(strHeader)
  objResponse.Write (strHdr)
 
 ' write out ObjectContext information
  objResponse.Write ("<strong>")

  ' write out security info
  If objContext.IsSecurityEnabled() Then
    objResponse.Write ("Security for component is enabled")
  Else
    objResponse.Write ("Security is not enabled")
  End If

  ' write out transaction info
  objResponse.Write ("<p>")
  If objContext.IsInTransaction() Then
    objResponse.Write ("object is within transaction")
  Else
    objResponse.Write ("object is not within transaction")
  End If
  objResponse.Write ("<p>")
 
  ' write out if contained in role
  If objContext.IsCallerInRole("test") Then
    objResponse.Write ("caller is in roll 'test'")
  End If

  ' write out count of properties
  objResponse.Write ("<p>")
  objResponse.Write ("count of properties is " + CStr(objContext.Count))
 
  objResponse.Write ("</strong>")
 
  Exit Sub
 
 ' handle errors
HandleError:
 objResponse.Write ("<p>")
   objResponse.Write ("Err number: " + " " + CStr(Err.Number) + _
                Err.Description)

End Sub


' create ObjectContext object and access Response object
' set to class variable and use Response to write out content
' to page
Public Sub objResponseMethod()

  Set objContext = GetObjectContext()
  Set objResponse = objContext("Response")
  objResponse.Write ("<H1>test One</H1>")
    
End Sub

' write out header using existing Response object reference
Public Sub objWriteHeader(strHeader As String)

  objResponse.Write ("<H1>" + strHeader + "</H1>")

End Sub


